Index: LMDZ6/branches/Portage_acc/libf/dyn3dmem/vlsplt_loc.F
===================================================================
--- LMDZ6/branches/Portage_acc/libf/dyn3dmem/vlsplt_loc.F	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/dyn3dmem/vlsplt_loc.F	(revision 4446)
@@ -15,5 +15,5 @@
       USE parallel_lmdz
       USE infotrac, ONLY : nqtot,tracers, ! CRisi                 &
-     &                     qperemin,masseqmin,ratiomin ! MVals et CRisi
+     &                     min_qParent,min_qMass,min_ratio ! MVals et CRisi
       IMPLICIT NONE
 c
@@ -341,9 +341,9 @@
             ! les calcule donc que de ijb à ije
             !MVals: veiller a ce qu'on n'ait pas de denominateur nul
-            masse(ij,l,iq2)=max(masse(ij,l,iq)*q(ij,l,iq),masseqmin)
-            if (q(ij,l,iq).gt.qperemin) then ! modif 13 nov 2020
+            masse(ij,l,iq2)=max(masse(ij,l,iq)*q(ij,l,iq),min_qMass)
+            if (q(ij,l,iq).gt.min_qParent) then ! modif 13 nov 2020
               Ratio(ij,l,iq2)=q(ij,l,iq2)/q(ij,l,iq)
             else
-              Ratio(ij,l,iq2)=ratiomin
+              Ratio(ij,l,iq2)=min_ratio
             endif
           enddo   
@@ -351,5 +351,5 @@
 c$OMP END DO NOWAIT
       enddo !do ifils=1,tracers(iq)%nqDescen
-      do ifils=1,tracers(iq)%nqChilds
+      do ifils=1,tracers(iq)%nqChildren
         iq2=tracers(iq)%iqDescen(ifils)
         call vlx_loc(Ratio,pente_max,masse,u_mq,ijb_x,ije_x,iq2)
@@ -363,5 +363,5 @@
          DO ij=ijb+1,ije
             !MVals: veiller a ce qu'on n'ait pas de denominateur nul
-            new_m=max(masse(ij,l,iq)+u_m(ij-1,l)-u_m(ij,l),masseqmin)
+            new_m=max(masse(ij,l,iq)+u_m(ij-1,l)-u_m(ij,l),min_qMass)
             q(ij,l,iq)=(q(ij,l,iq)*masse(ij,l,iq)+
      &        u_mq(ij-1,l)-u_mq(ij,l))
@@ -417,5 +417,5 @@
       USE parallel_lmdz
       USE infotrac, ONLY : nqtot,tracers, ! CRisi                 &
-     &                     qperemin,masseqmin,ratiomin ! MVals et CRisi    
+     &                     min_qParent,min_qMass,min_ratio ! MVals et CRisi    
       USE comconst_mod, ONLY: pi
       IMPLICIT NONE
@@ -726,5 +726,5 @@
 ! CRisi: appel récursif de l'advection sur les fils.
 ! Il faut faire ça avant d'avoir mis à jour q et masse
-      !write(*,*) 'vly 689: iq,nqChilds(iq)=',iq,tracers(iq)%nqChilds
+!     write(*,*)'vly 689: iq,nqChildren(iq)=',iq,tracers(iq)%nqChildren
 
       ijb=ij_begin-2*iip1
@@ -745,5 +745,5 @@
           DO ij=ijbm,ijem 
           !MVals: veiller a ce qu'on n'ait pas de denominateur nul
-            masse(ij,l,iq2)=max(masse(ij,l,iq)*q(ij,l,iq),masseqmin)
+            masse(ij,l,iq2)=max(masse(ij,l,iq)*q(ij,l,iq),min_qMass)
           enddo
 
@@ -751,8 +751,8 @@
           DO ij=ijb,ije
           !MVals: veiller a ce qu'on n'ait pas de denominateur nul
-            if (q(ij,l,iq).gt.qperemin) then ! modif 13 nov 2020
+            if (q(ij,l,iq).gt.min_qParent) then ! modif 13 nov 2020
               Ratio(ij,l,iq2)=q(ij,l,iq2)/q(ij,l,iq)
             else
-              Ratio(ij,l,iq2)=ratiomin  
+              Ratio(ij,l,iq2)=min_ratio  
             endif     
           enddo !DO ij=ijbm,ijem  
@@ -761,5 +761,5 @@
       enddo
 
-      do ifils=1,tracers(iq)%nqChilds
+      do ifils=1,tracers(iq)%nqChildren
         iq2=tracers(iq)%iqDescen(ifils)
         call vly_loc(Ratio,pente_max,masse,qbyv,iq2)
@@ -885,5 +885,5 @@
       USE vlz_mod
       USE infotrac, ONLY : nqtot,tracers, ! CRisi                 &
-     &                     qperemin,masseqmin,ratiomin ! MVals et CRisi
+     &                     min_qParent,min_qMass,min_ratio ! MVals et CRisi
       
       IMPLICIT NONE
@@ -1148,5 +1148,5 @@
 ! CRisi: appel récursif de l'advection sur les fils.
 ! Il faut faire ça avant d'avoir mis à jour q et masse
-      !write(*,*) 'vlsplt 942: iq,nqChilds(iq)=',iq,tracers(iq)%nqChilds
+!     write(*,*)'vlsplt 942: iq,nqChildren(iq)=',iq,tracers(iq)%nqChildren
       do ifils=1,tracers(iq)%nqDescen
         iq2=tracers(iq)%iqDescen(ifils)
@@ -1155,9 +1155,9 @@
           DO ij=ijb,ije
            !MVals: veiller a ce qu'on n'ait pas de denominateur nul
-            masse(ij,l,iq2)=max(masse(ij,l,iq)*q(ij,l,iq),masseqmin)
-            if (q(ij,l,iq).gt.qperemin) then
+            masse(ij,l,iq2)=max(masse(ij,l,iq)*q(ij,l,iq),min_qMass)
+            if (q(ij,l,iq).gt.min_qParent) then
               Ratio(ij,l,iq2)=q(ij,l,iq2)/q(ij,l,iq)
             else
-              Ratio(ij,l,iq2)=ratiomin
+              Ratio(ij,l,iq2)=min_ratio
             endif
             !wq(ij,l,iq2)=wq(ij,l,iq) ! correction bug le 15mai2015
@@ -1169,5 +1169,5 @@
 c$OMP BARRIER
 
-      do ifils=1,tracers(iq)%nqChilds
+      do ifils=1,tracers(iq)%nqChildren
         iq2=tracers(iq)%iqDescen(ifils)
         call vlz_loc(Ratio,pente_max,masse,w,ijb_x,ije_x,iq2)
Index: LMDZ6/branches/Portage_acc/libf/dyn3dmem/vlspltgen_loc.F
===================================================================
--- LMDZ6/branches/Portage_acc/libf/dyn3dmem/vlspltgen_loc.F	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/dyn3dmem/vlspltgen_loc.F	(revision 4446)
@@ -28,5 +28,5 @@
       USE VAMPIR
       ! CRisi: on rajoute variables utiles d'infotrac  
-      USE infotrac, ONLY : nqtot, tracers,ok_iso_verif
+      USE infotrac, ONLY : nqtot, tracers, isoCheck
       USE vlspltgen_mod
       USE comconst_mod, ONLY: cpp
@@ -191,7 +191,5 @@
       ijb=ij_begin
       ije=ij_end  
-      if (ok_iso_verif) then
-        call check_isotopes(zq,ijb,ije,'vlspltgen_loc 191')
-      endif !if (ok_iso_verif) then   
+      call check_isotopes(zq,ijb,ije,'vlspltgen_loc 191')
 
 c$OMP BARRIER           
@@ -285,7 +283,5 @@
       if (pole_nord) ijb=ij_begin
       if (pole_sud)  ije=ij_end  
-      if (ok_iso_verif) then
-           call check_isotopes(zq,ij_begin,ij_end,'vlspltgen_loc 280')
-      endif !if (ok_iso_verif) then
+      call check_isotopes(zq,ij_begin,ij_end,'vlspltgen_loc 280')
 
       do iq=1,nqtot
@@ -328,5 +324,5 @@
 
       
-      if (ok_iso_verif) then
+      IF(isoCheck) THEN
            call check_isotopes(zq,ij_begin,ij_end,'vlspltgen_loc 326')
            ijb=ij_begin-2*iip1
@@ -335,5 +331,5 @@
            if (pole_sud)  ije=ij_end
            call check_isotopes(zq,ijb,ije,'vlspltgen_loc 336')
-      endif !if (ok_iso_verif) then  
+      END IF
 
       do iq = 1, nqtot
@@ -355,7 +351,5 @@
        enddo
 
-      if (ok_iso_verif) then
-           call check_isotopes(zq,ij_begin,ij_end,'vlspltgen_loc 357')
-      endif !if (ok_iso_verif) then
+      call check_isotopes(zq,ij_begin,ij_end,'vlspltgen_loc 357')
 
       do iq = 1, nqtot
@@ -416,7 +410,5 @@
 
 
-      if (ok_iso_verif) then
-           call check_isotopes(zq,ij_begin,ij_end,'vlspltgen_loc 429')
-      endif !if (ok_iso_verif) then 
+      call check_isotopes(zq,ij_begin,ij_end,'vlspltgen_loc 429')
 
 c$OMP BARRIER
@@ -461,7 +453,5 @@
 
       !write(*,*) 'vlspltgen_loc 494'
-      if (ok_iso_verif) then
-           call check_isotopes(zq,ij_begin,ij_end,'vlspltgen_loc 461')
-      endif !if (ok_iso_verif) then
+      call check_isotopes(zq,ij_begin,ij_end,'vlspltgen_loc 461')
 
       do iq=1,nqtot
@@ -481,7 +471,5 @@
        enddo !do iq=1,nqtot
 
-      if (ok_iso_verif) then
-           call check_isotopes(zq,ij_begin,ij_end,'vlspltgen_loc 493')
-      endif !if (ok_iso_verif) then
+      call check_isotopes(zq,ij_begin,ij_end,'vlspltgen_loc 493')
 
       do iq=1,nqtot
@@ -504,7 +492,5 @@
 
       !write(*,*) 'vlspltgen 550: apres derniere serie de call vlx'
-      if (ok_iso_verif) then
-           call check_isotopes(zq,ij_begin,ij_end,'vlspltgen_loc 521')
-      endif !if (ok_iso_verif) then
+      call check_isotopes(zq,ij_begin,ij_end,'vlspltgen_loc 521')
      
       ijb=ij_begin
@@ -541,7 +527,5 @@
       ENDDO !DO iq=1,nqtot
         
-      if (ok_iso_verif) then
-           call check_isotopes(q,ij_begin,ij_end,'vlspltgen_loc 557')
-      endif !if (ok_iso_verif) then
+      call check_isotopes(q,ij_begin,ij_end,'vlspltgen_loc 557')
 
 c$OMP BARRIER
Index: LMDZ6/branches/Portage_acc/libf/dyn3dmem/vlspltqs_loc.F
===================================================================
--- LMDZ6/branches/Portage_acc/libf/dyn3dmem/vlspltqs_loc.F	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/dyn3dmem/vlspltqs_loc.F	(revision 4446)
@@ -13,5 +13,5 @@
       USE parallel_lmdz
       USE infotrac, ONLY : nqtot,tracers, ! CRisi                 &
-     &                     qperemin,masseqmin,ratiomin ! MVals et CRisi
+     &                     min_qParent,min_qMass,min_ratio ! MVals et CRisi
       IMPLICIT NONE
 c
@@ -337,6 +337,6 @@
 ! CRisi: appel recursif de l'advection sur les fils.
 ! Il faut faire ca avant d'avoir mis a jour q et masse
-      !write(*,*) 'vlspltqs 336: iq,ijb_x,nqChilds(iq)=',
-!     &     iq,ijb_x,tracers(iq)%nqChilds
+      !write(*,*) 'vlspltqs 336: iq,ijb_x,nqChildren(iq)=',
+!     &     iq,ijb_x,tracers(iq)%nqChildren
 
       do ifils=1,tracers(iq)%nqDescen
@@ -346,9 +346,9 @@
           DO ij=ijb,ije
             !MVals: veiller a ce qu'on n'ait pas de denominateur nul
-            masse(ij,l,iq2)=max(masse(ij,l,iq)*q(ij,l,iq),masseqmin)
-            if (q(ij,l,iq).gt.qperemin) then ! modif 13 nov 2020
+            masse(ij,l,iq2)=max(masse(ij,l,iq)*q(ij,l,iq),min_qMass)
+            if (q(ij,l,iq).gt.min_qParent) then ! modif 13 nov 2020
               Ratio(ij,l,iq2)=q(ij,l,iq2)/q(ij,l,iq)
             else
-              Ratio(ij,l,iq2)=ratiomin
+              Ratio(ij,l,iq2)=min_ratio
             endif 
           enddo   
@@ -356,5 +356,5 @@
 c$OMP END DO NOWAIT
       enddo
-      do ifils=1,tracers(iq)%nqChilds
+      do ifils=1,tracers(iq)%nqChildren
         iq2=tracers(iq)%iqDescen(ifils)
         !write(*,*) 'vlxqs 349: on appelle vlx pour iq2=',iq2
@@ -370,5 +370,5 @@
          DO ij=ijb+1,ije
             !MVals: veiller a ce qu'on n'ait pas de denominateur nul
-            new_m=max(masse(ij,l,iq)+u_m(ij-1,l)-u_m(ij,l),masseqmin)
+            new_m=max(masse(ij,l,iq)+u_m(ij-1,l)-u_m(ij,l),min_qMass)
             q(ij,l,iq)=(q(ij,l,iq)*masse(ij,l,iq)+
      &      u_mq(ij-1,l)-u_mq(ij,l))
@@ -423,5 +423,5 @@
       USE parallel_lmdz
       USE infotrac, ONLY : nqtot,tracers, ! CRisi                 &
-     &                     qperemin,masseqmin,ratiomin ! MVals et CRisi
+     &                     min_qParent,min_qMass,min_ratio ! MVals et CRisi
       USE comconst_mod, ONLY: pi
       IMPLICIT NONE
@@ -729,5 +729,6 @@
 ! CRisi: appel recursif de l'advection sur les fils.
 ! Il faut faire ca avant d'avoir mis a jour q et masse
-      !write(*,*) 'vlyqs 689: iq,nqChilds(iq)=',iq,tracers(iq)%nqChilds
+!     write(*,*)'vlyqs 689: iq,nqChildren(iq)=',iq,
+!    &             tracers(iq)%nqChildren
       
       ijb=ij_begin-2*iip1
@@ -751,5 +752,5 @@
           DO ij=ijbm,ijem 
             !MVals: veiller a ce qu'on n'ait pas de denominateur nul
-            masse(ij,l,iq2)=max(masse(ij,l,iq)*q(ij,l,iq),masseqmin)
+            masse(ij,l,iq2)=max(masse(ij,l,iq)*q(ij,l,iq),min_qMass)
           enddo !DO ij=ijbm,ijem 
 
@@ -758,8 +759,8 @@
             !MVals: veiller a ce qu'on n'ait pas de denominateur nul
             !write(lunout,*) 'ij,l,q(ij,l,iq)=',ij,l,q(ij,l,iq)
-            if (q(ij,l,iq).gt.qperemin) then ! modif 13 nov 2020
+            if (q(ij,l,iq).gt.min_qParent) then ! modif 13 nov 2020
               Ratio(ij,l,iq2)=q(ij,l,iq2)/q(ij,l,iq)
             else
-              Ratio(ij,l,iq2)=ratiomin   
+              Ratio(ij,l,iq2)=min_ratio   
             endif
           enddo !DO ij=ijbm,ijem
@@ -767,5 +768,5 @@
 c$OMP END DO NOWAIT
       enddo
-      do ifils=1,tracers(iq)%nqChilds
+      do ifils=1,tracers(iq)%nqChildren
         iq2=tracers(iq)%iqDescen(ifils)
         !write(lunout,*) 'vly: appel recursiv vly iq2=',iq2
Index: LMDZ6/branches/Portage_acc/libf/dyn3dmem/writedyn_xios.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/dyn3dmem/writedyn_xios.F90	(revision 4446)
+++ LMDZ6/branches/Portage_acc/libf/dyn3dmem/writedyn_xios.F90	(revision 4446)
@@ -0,0 +1,184 @@
+
+! $Id$
+!
+      SUBROUTINE writedyn_xios( vcov, ucov,teta,ppk,phi,q, &
+     &                           masse,ps,phis)
+
+#ifdef CPP_XIOS
+      USE xios
+      USE parallel_lmdz
+      USE misc_mod
+      USE infotrac, ONLY : nqtot
+      use com_io_dyn_mod, only : histaveid,histvaveid,histuaveid
+      USE comconst_mod, ONLY: cpp
+      USE temps_mod, ONLY: itau_dyn
+      USE mod_xios_dyn3dmem, ONLY : writefield_dyn_u, writefield_dyn_v
+      
+      implicit none
+!
+!   Ecriture du fichier histoire au format xios
+!
+!
+!   Entree:
+!      vcov: vents v covariants
+!      ucov: vents u covariants
+!      teta: temperature potentielle
+!      phi : geopotentiel instantane
+!      q   : traceurs
+!      masse: masse
+!      ps   :pression au sol
+!      phis : geopotentiel au sol
+!      
+!   L. Fairhead, LMD, 03/21
+!
+! =====================================================================
+!
+!   Declarations
+      include "dimensions.h"
+      include "paramet.h"
+      include "comgeom.h"
+      include "description.h"
+      include "iniprint.h"
+
+!
+!   Arguments
+!
+
+      REAL vcov(ijb_v:ije_v,llm),ucov(ijb_u:ije_u,llm) 
+      REAL teta(ijb_u:ije_u,llm),phi(ijb_u:ije_u,llm)
+      REAL ppk(ijb_u:ije_u,llm)                  
+      REAL ps(ijb_u:ije_u),masse(ijb_u:ije_u,llm)                   
+      REAL phis(ijb_u:ije_u)                  
+      REAL q(ijb_u:ije_u,llm,nqtot)
+      integer time
+
+
+!   Variables locales
+!
+      INTEGER,SAVE,ALLOCATABLE :: ndex2d(:),ndexu(:),ndexv(:)
+      INTEGER :: iq, ii, ll
+      REAL,SAVE,ALLOCATABLE :: tm(:,:)
+      REAL,SAVE,ALLOCATABLE :: vnat(:,:),unat(:,:)
+      REAL,SAVE,ALLOCATABLE :: vbuffer(:,:)
+      logical ok_sync
+      integer itau_w
+      integer :: ijb,ije,jjn
+      LOGICAL,SAVE :: first=.TRUE.
+      LOGICAL,SAVE :: debuglf=.true.
+!$OMP THREADPRIVATE(debuglf)
+!$OMP THREADPRIVATE(first)
+
+!
+!  Initialisations
+!
+
+!      WRITE(*,*)'IN WRITEDYN_XIOS'
+      IF (first) THEN
+!$OMP BARRIER
+!$OMP MASTER
+        ALLOCATE(unat(ijb_u:ije_u,llm))
+        ALLOCATE(vnat(ijb_v:ije_v,llm))
+        IF (pole_sud) THEN
+           ALLOCATE(vbuffer(ijb_v:ije_v+iip1,llm))
+        ELSE
+           ALLOCATE(vbuffer(ijb_v:ije_v+iip1,llm))
+        ENDIF
+        ALLOCATE(tm(ijb_u:ije_u,llm))
+        ALLOCATE(ndex2d(ijnb_u*llm))
+        ALLOCATE(ndexu(ijnb_u*llm))
+        ALLOCATE(ndexv(ijnb_v*llm))
+        unat = 0.; vnat = 0.; tm = 0. ;
+        ndex2d = 0
+        ndexu = 0
+        ndexv = 0
+        vbuffer=0.
+!$OMP END MASTER
+!$OMP BARRIER
+        first=.FALSE.
+      ENDIF
+      
+      ok_sync = .TRUE.
+      itau_w = itau_dyn + time
+
+! Passage aux composantes naturelles du vent
+      call covnat_loc(llm, ucov, vcov, unat, vnat)
+
+!
+!  Appels a histwrite pour l'ecriture des variables a sauvegarder
+!
+!  Vents U
+!
+      ijb=ij_begin
+      ije=ij_end
+      jjn=jj_nb
+     
+      CALL writefield_dyn_u('U', unat(ijb:ije,:))
+
+!
+!  Vents V
+!
+      ije=ij_end
+      IF (pole_sud) THEN
+         jjn=jj_nb-1
+         ije=ij_end-iip1
+      ENDIF
+      vbuffer(ijb:ije,:)=vnat(ijb:ije,:)
+
+
+      IF (pole_sud) THEN
+         CALL writefield_dyn_v('V', vbuffer(ijb:ije+iip1,:))
+      ELSE
+         CALL writefield_dyn_v('V', vbuffer(ijb:ije,:))
+      ENDIF
+      
+
+      
+!
+!  Temperature potentielle moyennee
+!
+      ijb=ij_begin
+      ije=ij_end
+      jjn=jj_nb
+     CALL writefield_dyn_u('THETA', teta(ijb:ije,:))
+
+!
+!  Temperature moyennee
+!
+
+!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)       
+      do ll=1,llm
+        do ii = ijb, ije
+          tm(ii,ll) = teta(ii,ll) * ppk(ii,ll)/cpp
+        enddo
+      enddo
+!$OMP ENDDO
+      CALL writefield_dyn_u('TEMP', tm(ijb:ije,:))
+
+
+!
+!  Geopotentiel
+!
+      CALL writefield_dyn_u('PHI', phi(ijb:ije,:))
+
+
+!
+! Tracers?
+!
+!        DO iq=1,nqtot
+!        ENDDO
+
+
+!
+!  Masse
+!
+      CALL writefield_dyn_u('MASSE', masse(ijb:ije,:))
+
+
+!
+!  Pression au sol
+!
+      CALL writefield_dyn_u('PS', ps(ijb:ije))
+
+#endif
+
+      END
Index: LMDZ6/branches/Portage_acc/libf/dynphy_lonlat/inigeomphy_mod.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/dynphy_lonlat/inigeomphy_mod.F90	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/dynphy_lonlat/inigeomphy_mod.F90	(revision 4446)
@@ -25,5 +25,5 @@
   USE nrtype, ONLY: pi
   USE comvert_mod, ONLY: preff, ap, bp, aps, bps, presnivs, &
-                         scaleheight, pseudoalt
+                         scaleheight, pseudoalt, presinter
   USE vertical_layers_mod, ONLY: init_vertical_layers
   IMPLICIT NONE
@@ -233,5 +233,5 @@
   ! copy over preff , ap(), bp(), etc 
   CALL init_vertical_layers(nlayer,preff,scaleheight, &
-                            ap,bp,aps,bps,presnivs,pseudoalt)
+                            ap,bp,aps,bps,presnivs,presinter,pseudoalt)
 
 !$OMP END PARALLEL
Index: LMDZ6/branches/Portage_acc/libf/dynphy_lonlat/phylmd/callphysiq_mod.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/dynphy_lonlat/phylmd/callphysiq_mod.F90	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/dynphy_lonlat/phylmd/callphysiq_mod.F90	(revision 4446)
@@ -20,6 +20,10 @@
 
   USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat
-  USE control_mod, ONLY: planet_type
+  USE control_mod, ONLY: planet_type, ok_dyn_xios
   USE physiq_mod, ONLY: physiq
+#ifdef CPP_XIOS
+  USE mod_xios_dyn3dmem, ONLY : dyn3d_ctx_handle
+  USE xios, ONLY : xios_set_current_context
+#endif
   IMPLICIT NONE
 
@@ -90,4 +94,13 @@
               zdpsrf_omp)
 
+! switching back to LMDZDYN context
+#ifdef CPP_XIOS
+!$OMP MASTER
+  if (ok_dyn_xios) then
+     CALL xios_set_current_context(dyn3d_ctx_handle)
+  endif
+!$OMP END MASTER
+#endif  
+
 
 END SUBROUTINE call_physiq
Index: LMDZ6/branches/Portage_acc/libf/dynphy_lonlat/phylmd/ce0l.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/dynphy_lonlat/phylmd/ce0l.F90	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/dynphy_lonlat/phylmd/ce0l.F90	(revision 4446)
@@ -23,5 +23,5 @@
   USE netcdf,         ONLY: NF90_OPEN, NF90_NOWRITE, NF90_CLOSE, NF90_NOERR,    &
          NF90_INQUIRE_DIMENSION, NF90_INQ_DIMID, NF90_INQ_VARID, NF90_GET_VAR
-  USE infotrac,       ONLY: type_trac, infotrac_init
+  USE infotrac,       ONLY: init_infotrac
   USE dimphy,         ONLY: klon
   USE test_disvert_m, ONLY: test_disvert
@@ -108,5 +108,5 @@
   calnd='gregorian'
   SELECT CASE(calend)
-    CASE('earth_360d');CALL ioconf_calendar('360d');   calnd='with 360 days/year'
+    CASE('earth_360d');CALL ioconf_calendar('360_day');   calnd='with 360 days/year'
     CASE('earth_365d');CALL ioconf_calendar('noleap'); calnd='with no leap year'
     CASE('earth_366d');CALL ioconf_calendar('366d');   calnd='with leap years only'
@@ -132,5 +132,5 @@
 
 !--- Tracers initializations
-  CALL infotrac_init()
+  CALL init_infotrac()
 
   CALL inifilr()
Index: LMDZ6/branches/Portage_acc/libf/dynphy_lonlat/phylmd/iniphysiq_mod.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/dynphy_lonlat/phylmd/iniphysiq_mod.F90	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/dynphy_lonlat/phylmd/iniphysiq_mod.F90	(revision 4446)
@@ -16,5 +16,5 @@
   USE mod_phys_lmdz_para, ONLY: klon_omp ! number of columns (on local omp grid)
   USE vertical_layers_mod, ONLY : init_vertical_layers
-  USE infotrac, ONLY: nbtr,nqCO2,tracers,isotopes,type_trac,conv_flg,pbl_flg,nqtottr
+  USE infotrac, ONLY: nbtr, type_trac
 #ifdef CPP_StratAer
   USE infotrac_phy, ONLY: nbtr_bin, nbtr_sulgas, id_OCS_strat, &
@@ -30,5 +30,5 @@
   USE mod_phys_lmdz_omp_data, ONLY: klon_omp
 #endif
-  USE control_mod, ONLY: dayref,anneeref,day_step,nday,offline, iphysiq, config_inca
+  USE control_mod, ONLY: dayref,anneeref,day_step,nday,offline, iphysiq
   USE inifis_mod, ONLY: inifis
   USE time_phylmdz_mod, ONLY: init_time
@@ -158,5 +158,5 @@
 
   ! Initialize tracer names, numbers, etc. for physics
-  CALL init_infotrac_phy(type_trac, tracers, isotopes, nqtottr, nqCO2, pbl_flg, conv_flg)
+  CALL init_infotrac_phy
 
   ! Initializations for Reprobus
@@ -187,5 +187,5 @@
   END IF
 
-  IF (type_trac == 'inca' .OR. type_trac == 'inco') THEN
+  IF (ANY(type_trac == ['inca','inco'])) THEN
 #ifdef INCA
      CALL init_inca_dim_reg(nbp_lon, nbp_lat - 1, &
@@ -194,10 +194,4 @@
   END IF
 
-  IF (type_trac == 'repr') THEN
-#ifdef REPROBUS
-     CALL Init_chem_rep_phys(klon_omp,nbp_lev)
-#endif
-  END IF
-
 !$OMP END PARALLEL
 
Index: LMDZ6/branches/Portage_acc/libf/dynphy_lonlat/phylmd/init_ssrf_m.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/dynphy_lonlat/phylmd/init_ssrf_m.F90	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/dynphy_lonlat/phylmd/init_ssrf_m.F90	(revision 4446)
@@ -3,12 +3,13 @@
 !*******************************************************************************
 
-  USE indice_sol_mod, ONLY: is_ter, is_oce, is_oce, is_lic, epsfra
+  USE indice_sol_mod,     ONLY: is_ter, is_oce, is_oce, is_lic, epsfra
   USE dimphy,             ONLY: klon, zmasq
   USE phys_state_var_mod, ONLY: pctsrf
-  USE geometry_mod, ONLY : longitude_deg, latitude_deg
+  USE geometry_mod,       ONLY : longitude_deg, latitude_deg
   USE grid_atob_m,        ONLY: grille_m
   USE ioipsl,             ONLY: flininfo, flinopen, flinget, flinclo
   USE ioipsl_getin_p_mod, ONLY: getin_p
-  USE comconst_mod, ONLY: im, pi
+  USE comconst_mod,       ONLY: im, pi
+  USE surface_data,       ONLY: landice_opt
 
   CHARACTER(LEN=256), PARAMETER :: icefname="landiceref.nc", icevar="landice"
@@ -58,64 +59,75 @@
 ! Sub-surfaces initialization
 !*******************************************************************************
-!--- Read and interpolate on model T-grid soil fraction and soil ice fraction.
-  CALL flininfo(icefname, iml_lic, jml_lic, llm_tmp, ttm_tmp, fid)
-  ALLOCATE(lat_lic(iml_lic,jml_lic),lon_lic(iml_lic,jml_lic))
-  ALLOCATE(fraclic(iml_lic,jml_lic))
-  CALL flinopen(icefname, .FALSE., iml_lic, jml_lic, llm_tmp,  &
- &               lon_lic, lat_lic, lev, ttm_tmp, itaul, date, dt, fid)
-  CALL flinget(fid, icevar, iml_lic, jml_lic, llm_tmp, ttm_tmp, 1,1, fraclic)
-  CALL flinclo(fid)
-  WRITE(lunout,*)'landice dimensions: iml_lic, jml_lic : ',iml_lic,jml_lic
+  IF (landice_opt .LT. 2) THEN
+     ! Continue with reading landice.nc file
+     WRITE(lunout,*)"Read landice.nc file to attribute is_lic fraction"
 
-  ALLOCATE(dlon_lic(iml_lic),dlat_lic(jml_lic))
-  dlon_lic(:)=lon_lic(:,1); IF(MAXVAL(dlon_lic)>pi) dlon_lic=dlon_lic*pi/180.
-  dlat_lic(:)=lat_lic(1,:); IF(MAXVAL(dlat_lic)>pi) dlat_lic=dlat_lic*pi/180.
-  DEALLOCATE(lon_lic,lat_lic); ALLOCATE(flic_tmp(iip1,jjp1))
-  CALL grille_m(dlon_lic,dlat_lic,fraclic,rlonv(1:iim),rlatu,flic_tmp(1:iim,:))
-  flic_tmp(iip1,:)=flic_tmp(1,:)
-
-!--- To the physical grid
-  pctsrf(:,:) = 0.
-  CALL gr_dyn_fi(1, iip1, jjp1, klon, flic_tmp, pctsrf(:,is_lic))
-  DEALLOCATE(flic_tmp)
-
-!--- Adequation with soil/sea mask
-  WHERE(pctsrf(:,is_lic)<EPSFRA) pctsrf(:,is_lic)=0. 
-  WHERE(zmasq(:)<EPSFRA)         pctsrf(:,is_lic)=0.
-  pctsrf(:,is_ter)=zmasq(:)
-  DO ji=1,klon
-    IF(zmasq(ji)>EPSFRA) THEN 
-      IF(pctsrf(ji,is_lic)>=zmasq(ji)) THEN
-        pctsrf(ji,is_lic)=zmasq(ji)
-        pctsrf(ji,is_ter)=0.
-      ELSE
-        pctsrf(ji,is_ter)=zmasq(ji)-pctsrf(ji,is_lic)
-        IF(pctsrf(ji,is_ter)<EPSFRA) THEN
-          pctsrf(ji,is_ter)=0.
-          pctsrf(ji,is_lic)=zmasq(ji)
-        END IF 
-      END IF 
-    END IF 
-  END DO 
-
-
-  !--- Option no_ter_antartique removes all land fractions souther than 60S.
-  !--- Land ice is set instead of the land fractions on these latitudes.
-  !--- The ocean and sea-ice fractions are not changed.
-  no_ter_antartique=.FALSE.
-  CALL getin_p('no_ter_antartique',no_ter_antartique)
-  WRITE(lunout,*)"no_ter_antartique=",no_ter_antartique
-  IF (no_ter_antartique) THEN
-     ! Remove all land fractions souther than 60S and set land-ice instead
-     WRITE(lunout,*) "Remove land fractions souther than 60deg south by increasing"
-     WRITE(lunout,*) "the continental ice fractions. No land can now be found at Antartic."
-     DO ji=1, klon
-        IF (latitude_deg(ji)<-60.0) THEN
-           pctsrf(ji,is_lic) = pctsrf(ji,is_lic) + pctsrf(ji,is_ter)
-           pctsrf(ji,is_ter) = 0
+     !--- Read and interpolate on model T-grid soil fraction and soil ice fraction.
+     CALL flininfo(icefname, iml_lic, jml_lic, llm_tmp, ttm_tmp, fid)
+     ALLOCATE(lat_lic(iml_lic,jml_lic),lon_lic(iml_lic,jml_lic))
+     ALLOCATE(fraclic(iml_lic,jml_lic))
+     CALL flinopen(icefname, .FALSE., iml_lic, jml_lic, llm_tmp,  &
+          &               lon_lic, lat_lic, lev, ttm_tmp, itaul, date, dt, fid)
+     CALL flinget(fid, icevar, iml_lic, jml_lic, llm_tmp, ttm_tmp, 1,1, fraclic)
+     CALL flinclo(fid)
+     WRITE(lunout,*)'landice dimensions: iml_lic, jml_lic : ',iml_lic,jml_lic
+     
+     ALLOCATE(dlon_lic(iml_lic),dlat_lic(jml_lic))
+     dlon_lic(:)=lon_lic(:,1); IF(MAXVAL(dlon_lic)>pi) dlon_lic=dlon_lic*pi/180.
+     dlat_lic(:)=lat_lic(1,:); IF(MAXVAL(dlat_lic)>pi) dlat_lic=dlat_lic*pi/180.
+     DEALLOCATE(lon_lic,lat_lic); ALLOCATE(flic_tmp(iip1,jjp1))
+     CALL grille_m(dlon_lic,dlat_lic,fraclic,rlonv(1:iim),rlatu,flic_tmp(1:iim,:))
+     flic_tmp(iip1,:)=flic_tmp(1,:)
+     
+     !--- To the physical grid
+     pctsrf(:,:) = 0.
+     CALL gr_dyn_fi(1, iip1, jjp1, klon, flic_tmp, pctsrf(:,is_lic))
+     DEALLOCATE(flic_tmp)
+     
+     !--- Adequation with soil/sea mask
+     WHERE(pctsrf(:,is_lic)<EPSFRA) pctsrf(:,is_lic)=0. 
+     WHERE(zmasq(:)<EPSFRA)         pctsrf(:,is_lic)=0.
+     pctsrf(:,is_ter)=zmasq(:)
+     DO ji=1,klon
+        IF(zmasq(ji)>EPSFRA) THEN 
+           IF(pctsrf(ji,is_lic)>=zmasq(ji)) THEN
+              pctsrf(ji,is_lic)=zmasq(ji)
+              pctsrf(ji,is_ter)=0.
+           ELSE
+              pctsrf(ji,is_ter)=zmasq(ji)-pctsrf(ji,is_lic)
+              IF(pctsrf(ji,is_ter)<EPSFRA) THEN
+                 pctsrf(ji,is_ter)=0.
+                 pctsrf(ji,is_lic)=zmasq(ji)
+              END IF
+           END IF
         END IF
      END DO
+     
+     
+     !--- Option no_ter_antartique removes all land fractions souther than 60S.
+     !--- Land ice is set instead of the land fractions on these latitudes.
+     !--- The ocean and sea-ice fractions are not changed.
+     no_ter_antartique=.FALSE.
+     CALL getin_p('no_ter_antartique',no_ter_antartique)
+     WRITE(lunout,*)"no_ter_antartique=",no_ter_antartique
+     IF (no_ter_antartique) THEN
+        ! Remove all land fractions souther than 60S and set land-ice instead
+        WRITE(lunout,*) "Remove land fractions souther than 60deg south by increasing"
+        WRITE(lunout,*) "the continental ice fractions. No land can now be found at Antartic."
+        DO ji=1, klon
+           IF (latitude_deg(ji)<-60.0) THEN
+              pctsrf(ji,is_lic) = pctsrf(ji,is_lic) + pctsrf(ji,is_ter)
+              pctsrf(ji,is_ter) = 0
+           END IF
+        END DO
+     END IF
+     
+  ELSE
+     ! landice_opt=2 and higher
+     WRITE(lunout,*) 'No landice is attributed is_lic sub-surface because landice_opt=2 or higher.'
+     WRITE(lunout,*) 'This means that the land model will handel land ice as well as all other land areas.'
+     pctsrf(:,is_ter) = zmasq(:)
+     pctsrf(:,is_lic) = 0.0
   END IF
-
 
 !--- Sub-surface ocean and sea ice (sea ice set to zero for start).
Index: LMDZ6/branches/Portage_acc/libf/dynphy_lonlat/phylmd/limit_netcdf.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/dynphy_lonlat/phylmd/limit_netcdf.F90	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/dynphy_lonlat/phylmd/limit_netcdf.F90	(revision 4446)
@@ -424,5 +424,5 @@
   IF(NF90_GET_ATT(ncid, varid, 'calendar', cal_in)/=NF90_NOERR) THEN
     SELECT CASE(mode)
-      CASE('RUG', 'ALB'); cal_in='360d'
+      CASE('RUG', 'ALB'); cal_in='360_day'
       CASE('SIC', 'SST'); cal_in='gregorian'
     END SELECT
@@ -492,5 +492,5 @@
       !--- DROPPED FOR BCS DATA (FRACTIONS CAN BE HIGHER THAN 1)
       IF(ll.AND.ix_sic/=1.AND.mode=='SIC') &
-        CALL abort_physic(mode,'unrealistic '//TRIM(mode)//' found: '//TRIM(str))
+        CALL abort_physic(mode,'unrealistic '//TRIM(mode)//' found: '//TRIM(str), 1)
 
     END IF
@@ -641,5 +641,5 @@
   ALLOCATE(champo(klon, ndays))
   DO k=1, ndays
-    CALL gr_dyn_fi(1, iip1, jjp1, klon, champan(1, 1, k), champo(1, k))
+    CALL gr_dyn_fi(1, iip1, jjp1, klon, champan(1, 1, k), champo(:, k))
   END DO
   DEALLOCATE(champan)
Index: LMDZ6/branches/Portage_acc/libf/filtrez/filtreg.F
===================================================================
--- LMDZ6/branches/Portage_acc/libf/filtrez/filtreg.F	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/filtrez/filtreg.F	(revision 4446)
@@ -71,4 +71,6 @@
 
       INTEGER :: sdd1_type, sdd2_type
+
+      if ( iim == 1 ) return ! no filtre in 2D y-z
 
       IF (first) THEN
Index: LMDZ6/branches/Portage_acc/libf/filtrez/filtreg_mod.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/filtrez/filtreg_mod.F90	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/filtrez/filtreg_mod.F90	(revision 4446)
@@ -66,4 +66,5 @@
     !-----------------------------------------------------------
     !
+    if ( iim == 1 ) return ! No filtre in 2D y-z
 
     pi       = 2. * ASIN( 1. )
@@ -125,4 +126,5 @@
     !
     colat0  =  MIN( 0.5, dymin/dxmin )
+    ! colat0  =  1.
     !
     IF( .NOT.fxyhypb.AND.ysinus )  THEN
Index: LMDZ6/branches/Portage_acc/libf/grid/dimension/makdim
===================================================================
--- LMDZ6/branches/Portage_acc/libf/grid/dimension/makdim	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/grid/dimension/makdim	(revision 4446)
@@ -12,5 +12,5 @@
 fi
 
-if (($1 % 8 != 0)) && (( $# == 3 ))
+if ( ( ($1 % 8 != 0)) && (( $# == 3 ) ) || ( $1 == 1 ) )
 then
     echo "The number of longitudes must be a multiple of 8."
